from srblib import Tabular, Email

from .configurations import config_json

mainbody = '''Hi {name},

You have been alloted the following duties during exams.

{dutiesdata}

This is an autogenerated mail from examscheduler.

Regards,

Team ExamScheduler
'''

class Output:
    def __init__(self,filename):
        self.mat = Tabular(filename)

    def mail(self):
        subject = "Alloted Duties In examination"
        header = self.mat[0]
        if not 'mail' in header:
            return
        for teacher in self.mat:
            if teacher['mail']:
                data = [[],[]]
                for i in range(0,len(header)-1):
                    if (not teacher[i]) or teacher[i] == '-':
                        continue
                    data[0].append(header[i])
                    data[1].append(teacher[i])
                Output.__send_email(teacher['mail'],Output.__makebody(data),subject)


    @staticmethod
    def __makebody(data):
        infocols = ['Info','Name of Faculty Member','Total','mail','_rank','_total','_res','_credits','s_d_m_d']
        duties = ''
        for i in range(len(data[0])):
            print(data[0][i])
            if(data[0][i] in infocols):
                continue
            duties += str(data[0][i]) + ' : ' + str(data[1][i]) + '\n'
        body = mainbody.format(name=data[1][0],dutiesdata=duties)
        print(body)
        return body

    @staticmethod
    def __send_email(toaddr, body='', subject=''):
        mail = Email()
        mail.fromaddr = config_json['email']
        mail.password = config_json['password']
        mail.toaddr = toaddr
        mail.subject = subject
        mail.body = body
        mail.send()
